package de.thpeetz.kontor.media.views;

import com.vaadin.flow.component.ComponentEvent;
import com.vaadin.flow.component.ComponentEventListener;
import com.vaadin.flow.component.Key;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.button.ButtonVariant;
import com.vaadin.flow.component.checkbox.Checkbox;
import com.vaadin.flow.component.formlayout.FormLayout;
import com.vaadin.flow.component.orderedlayout.HorizontalLayout;
import com.vaadin.flow.component.textfield.TextField;
import com.vaadin.flow.data.binder.BeanValidationBinder;
import com.vaadin.flow.data.binder.Binder;
import de.thpeetz.kontor.media.data.MediaVideo;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class MediaVideoForm extends FormLayout {

    TextField url = new TextField("URL");
    TextField title = new TextField("Title");
    TextField fileName = new TextField("Dateiname");
    TextField cloudLink = new TextField("Cloud Link");
    Checkbox review = new Checkbox("Review");
    Checkbox shouldDownload = new Checkbox("Download");

    Button save = new Button("Save");
    Button delete = new Button("Delete");
    Button close = new Button("Cancel");

    Binder<MediaVideo> binder = new BeanValidationBinder<>(MediaVideo.class);

    public MediaVideoForm() {
        addClassName("mediavideo-form");
        binder.bindInstanceFields(this);
        add(url, 2);
        add(title, 2);
        add(fileName, 2);
        add(cloudLink, 2);
        add(review, shouldDownload, createButtonsLayout());
    }

    private HorizontalLayout createButtonsLayout() {
        save.addThemeVariants(ButtonVariant.LUMO_PRIMARY);
        delete.addThemeVariants(ButtonVariant.LUMO_ERROR);
        close.addThemeVariants(ButtonVariant.LUMO_TERTIARY);

        save.addClickShortcut(Key.ENTER);
        close.addClickShortcut(Key.ESCAPE);

        save.addClickListener(event -> validateAndSave());
        delete.addClickListener(event -> fireEvent(new DeleteEvent(this, binder.getBean())));
        close.addClickListener(event -> fireEvent(new CloseEvent(this)));

        binder.addStatusChangeListener(event -> {
            save.setEnabled(event.getBinder().isValid());
        });
        return new HorizontalLayout(save, delete, close);
    }

    private void validateAndSave() {
        if (binder.isValid()) {
            fireEvent(new SaveEvent(this, binder.getBean()));
        }
    }

    public void setMediaVideo(MediaVideo mediaVideo) {
        binder.setBean(mediaVideo);
    }

    public abstract static class MediaVideoFormEvent extends ComponentEvent<MediaVideoForm> {
        private MediaVideo mediaVideo;

        protected MediaVideoFormEvent(MediaVideoForm source, MediaVideo mediaVideo) {
            super(source, false);
            this.mediaVideo = mediaVideo;
        }

        public MediaVideo getMediaVideo() {
            return mediaVideo;
        }
    }

    public static class SaveEvent extends MediaVideoFormEvent {
        SaveEvent(MediaVideoForm source, MediaVideo mediaVideo) {
            super(source, mediaVideo);
        }
    }

    public static class DeleteEvent extends MediaVideoFormEvent {
        DeleteEvent(MediaVideoForm source, MediaVideo mediaVideo) {
            super(source, mediaVideo);
        }
    }

    public static class CloseEvent extends MediaVideoFormEvent {
        CloseEvent(MediaVideoForm source) {
            super(source, null);
        }
    }

    public void addDeleteListener(ComponentEventListener<DeleteEvent> listener) {
        addListener(DeleteEvent.class, listener);
    }

    public void addSaveListener(ComponentEventListener<SaveEvent> listener) {
        addListener(SaveEvent.class, listener);
    }

    public void addCloseListener(ComponentEventListener<CloseEvent> listener) {
        addListener(CloseEvent.class, listener);
    }
}
